// Growth2  an Illustrator script for Scriptographer 
// 
// Based on example script but ...
//    more parameters
//    generates a single path not a group so more style options
//    shares common processing with GrowthTool2 - apart from smoothing
//    can process multiple paths at once
// note : the batch version leaves paths for reuse 
//
// gw@westdale.demon.co.uk
//
// Interesting patterns with scale = 1, roation = 360/n and maxrep = n-1
//
// some oddities with scale = 1 -  hack put in to be just less than 1


// Interface ---------------------------


var values = {
	scale: 0.95,
	maxrep: 100,
	minlength: 10,
	autorotate: true,
	rotate:-90,
};

var components = {
	scale: {
		label: 'Scale',
		type: 'number',
		range: [0.1, 1]
	},
	maxrep: {
		label: 'max reps',
		type: 'number',
		range: [1,200]
	},
	minlength: {
		label: 'min length',
		type: 'number',
		range: [1,200]
	},
	autorotate: {
		label:'autorotate', 
		value: true, 
		type: 'boolean'
	},
	rotate: {
		label: 'angle', 
		type: 'number'
	},
    Run: { 
        type: 'button',
        value:'Run',
        label: 'Execute',
        onClick: function() { Run(); }
    }
};

var palette = new Palette('Grow', components, values);


// ---------------------------------------------------------

function Run() {

   var paths = document.getItems({ type: Path, selected: true });
   
   if (paths.length) {
   
   
      for ( var p = 0; p < paths.length; p++) {
      
        ProcessPath(paths[p]) ; 
        
      }

   }else{
   
        Dialog.alert('Please select a path first.');
   }

} // fn Run  


// Main process ------------------------------------------

function ProcessPath(path) {
	 // common code with GrowthTool script

	// get frequently used params
	var scale = values.scale;
	// HACK: transform can be upset by scale = 1 and angle = 90, 45 etc 
	if (scale == 1){ scale = 0.9999 }  
	var autorotate = values.autorotate;
	var rotate = values.rotate;
	var minlength = values.minlength;
	var maxrep = values.maxrep;
	
	// smooth the hand drawn curve but does work well with an existing curve
	//path.pointsToCurves();

	var nextseg = path.clone();   

	for(var i = 0; i < maxrep; i++) {

		var lastCurve = path.curves.last;
		var point2 = lastCurve.getPoint(1);
		var angle2 = lastCurve.getTangent(1).angle;

		nextseg.scale(scale);

		var firstB = nextseg.curves[0];
		var point1 = firstB.getPoint(0);
		var angle1 = firstB.getTangent(0).angle;

		var angle;
		if (autorotate){
			 angle =  angle2 - angle1
		} else {
			angle = rotate;
		}	

		nextseg.rotate(angle, point1);	
		

		nextseg.position += point2 - point1;

		if (nextseg.length < minlength) {
		   break;
		} else {
		  path.join( nextseg.clone() );
		}
		
	} // loop repetitions
	
   nextseg.remove(); // remove the working segment
   
} // fn ProcessPath   -----------------------------------------
